#include "config.h"
#include "rules.h"
#include "parser.h"

#include <stdlib.h>	/* malloc, calloc, getenv */
#include <assert.h>	/* assert */
#include <errno.h>	/* errno */
#include <string.h>	/* strerror */
#include <stdint.h>	/* uint16_t */
#include <stdio.h>	/* *printf */



struct rules *condnet_config = NULL;
static int config_done = 0;



static const char *
config_filename(void) /* TODO */
{
	return NULL;
	/*
	const char *file;
	file = getenv("CONDNETRC");
	if (file == NULL) {
		file = 
	*/
}



static struct rules *
file_to_rules(void)
{
	const char *filename;
	filename = config_filename();
	if (filename == NULL) {
		return NULL;
	}
	return NULL;
}



struct rules *
env_to_rules(void)
{
	char *env;
	env = getenv("CONDNET_RULES");

	if (env == NULL) {
		return NULL;
	} else {
		return parser_buffer_to_rules(env);
	}
}



static void
configure(void)	/* FIXME TODO XXX */
{
	condnet_config = env_to_rules();
	if (condnet_config == NULL) {
		condnet_config = file_to_rules();
	}
	rules_to_log(condnet_config);
}



inline void
config_setup(void)
{
	if (config_done) {
		return;
	}
	configure();
	config_done = 1;
}



int
config_rule_to_str(char *buf, size_t len, const struct connection_rule *rule)
{
	return snprintf(buf, len, "%s/%d -> %s/%d (= %s/%d) -> %d%s/%d%s",
			rule->from_addr ? : "*", rule->from_port,
			rule->to_addr ? : "*", rule->to_port,
			rule->spoof_addr ? : "-", rule->spoof_port,
			rule->policy.ret, rule->policy.set_ret ? "!" : "~",
			rule->policy.err, rule->policy.set_err ? "!" : "~");
}
